# -*-python-*-

__package__    = "s60-simpleflickr"
__version__    = "1.0"
__author__     = "Aaron Straup Cope"
__url__        = "http://www.aaronland.info/python/s60-simplelibs/"
__cvsversion__ = "$Revision: 1.4 $"
__date__       = "$Date: 2007/05/17 16:50:09 $"
__copyright__  = "Copyright (c) 2006-2007 Aaron Straup Cope. Perl Artistic License."

# s60_include : */s60-simplejson/s60-simplejson.py
# s60_include : */s60-simplehttp/s60-simplehttp.py

import urllib
import md5

class simpleflickr :

    def __init__ (self, key, secret=None, token=None) :

        self.__host__     = 'api.flickr.com'
        self.__endpoint__ = '/services/rest'
        
        self.__apikey__    = key
        self.__appsecret__ = secret
        self.__authtoken__ = token

    #
    #
    #

    def get_token (self, frob) :
        pass

    #
    #
    #
    
    def get_frob (self) :
        pass
        
    #
    #
    #
    
    def execute_method (self, method, kwargs={}) :

        kwargs['method']  = method
        kwargs['format']  = 'json'
        kwargs['nojsoncallback'] = 1
        kwargs['api_key'] = self.__apikey__

        if self.__authtoken__ :
            kwargs['auth_token'] = self.__authtoken__        
            kwargs['api_sig'] = self.sign_args(kwargs)

        path = '%s?%s' % (self.__endpoint__, urllib.urlencode(kwargs))
        
        http = simplehttp()
        json = http.get(self.__host__, path)

        sj  = simplejson()
        return sj.loads(json)
        
    #
    #
    #
    
    def sign_args (self, args) :

        params = args.keys()
        params.sort()

        sig = unicode(self.__appsecret__)
        
        for key in params :
            sig += unicode(key) + unicode(args[key])

        return md5.md5(sig).hexdigest()

    #
    #
    #
    
if __name__ == '__main__' :

    import appuifw

    try :
        key = '50f8fe2a13c12d48ec4dfb1dc1f15cc8'
        
        fl  = simpleflickr(key)
        res = fl.execute_method('flickr.test.echo')
        appuifw.note(unicode("%s" % res), "info")
    except Exception, e :
        appuifw.note(unicode("%s" % e), "error")
