# -*-python-*-

__package__    = "s60-simpleflickrapp"
__version__    = "0.1"
__author__     = "Aaron Straup Cope"
__url__        = "http://www.aaronland.info/python/s60-simplelibs/"
__cvsversion__ = "$Revision: 1.17 $"
__date__       = "$Date: 2007/05/17 16:50:09 $"
__copyright__  = "Copyright (c) 2006-2007 Aaron Straup Cope. Perl Artistic License."

# s60_include : */s60-simplejson/s60-simplejson.py
# s60_include : */s60-simplehttp/s60-simplehttp.py  
# s60_include : */s60-simplestore/s60-simplestore.py
# s60_include : */s60-simplenumbers/s60-simplenumbers.py  
# s60_include : */s60-simpleflickr/s60-simpleflickr.py
# s60_include : */s60-simpleapp/s60-simpleapp.py

import appuifw
import graphics
import os
import os.path
import md5

#
#
#
    
class simpleflickrapp (simpleapp) :

    def __init__(self, key, secret, token) :

        simpleapp.__init__(self)

        self.__store__ = None
        self.__images__ = []
        self.__pending__ = []
	self.__show__ = False
        self.__logs__ = False
        
        self.__ball__ = 0
        self.__balltimer__ = None
        
    	self.__ph__   = None
        self.__sz__   = None
        
        self.__tw__   = {}
        self.__twim__ = {}
        self.__mode__ = None
        
        self.__canvas__ = None
        
        self.__fl__ = simpleflickr(key, secret, token)
        
    #
    #
    #

    def setup (self) :

        if not self.setup_simplestore('flickr') :
            return False

        try :
            self.draw_canvas()
        except Exception, e :
            self.error("Failed to draw canvas, %s" % e)

        try :
            self.show_icon()
        except Exception, e :
            self.error("can't show icon : %s" % e)
            return False

        appuifw.app.focus = self.focus_toggle
        
        self.setup_app_menu()        
        return True

    #
    #
    #
    
    def focus_toggle (self, focus) :
        # self.record_activity("focus : %s" % focus)
        
        toggle_windows = ['beachball', 'photo']

        for win in toggle_windows :

            if not self.__tw__.has_key(win) :
                continue

            if not self.__tw__[win] :
                continue

            if focus :
                self.__tw__[win].show()
            else :
                self.__tw__[win].hide()
                
    #
    #
    #
    
    def draw_canvas (self, screen_size='normal') :

        return
    
        if e32.in_emulator() :
            return

        appuifw.app.screen = screen_size
        
        import topwindow
        tw = topwindow.TopWindow()

        cv = appuifw.Canvas()
        sz = cv.size

        tw.size = sz
        tw.position = (0, 0)
        
        im = graphics.Image.new(sz)
	im.rectangle((0, 0, sz[0], sz[1]), outline=(0, 0, 0), width=2)

        tw.add_image(im, (0, 0))
        tw.show()

        self.__canvas__ = tw
        
    #
    #
    #

    def setup_app_menu (self) :

        menu = []

        menu.append((unicode("Show next photo"), self.show_next_image))
        
        if self.has_photo() :

            if self.__sz__ == 't' :
                menu.append((unicode("Show larger version"), self.toggle_flickr_photo))
            else :
                menu.append((unicode("Show smaller version"), self.toggle_flickr_photo))                

            menu.append((unicode("Add to favorites"), self.add_to_faves))
            menu.append((unicode("Open in browser"), self.show_in_browser))
            
        menu.append((unicode("Check for new photos"), self.poll))
        menu.append((unicode("Switch to logs"), self.switch_to_activity))

        appuifw.app.menu = menu

    #
    #
    #
    
    def has_photo (self) :

        if self.__ph__ :
            return True

        return False
    
    #
    #
    #

    def setup_activity_menu (self) :
        appuifw.app.menu = [
            (unicode("Switch to  photos"), self.switch_to_app)            
            ]        

    #
    #
    #

    def switch_to_app (self) :
        simpleapp.switch_to_app(self)
        self.__logs__ = False

    #
    #
    #
    
    def switch_to_activity (self) :
        simpleapp.switch_to_activity(self)
        self.__logs__ = True
        
    #
    #
    #
    
    def do_poll (self) :

        self.__show__ = False
        self.record_activity(u"Collecting images")        
        self.get_images()
        self.record_activity(u"Menu")        
        self.setup_app_menu()
        self.record_activity(u"Resting...")
        
    #
    #
    #

    def get_flickr_photos (self) :
    	self.error("You must define your own 'get_flickr_photos' method")
        return None

    #
    #
    #
    
    def add_to_faves (self) :
        if not self.__ph__ :
            self.error("No photo to add")
            return
        
        ph = self.__ph__
        ok = self.flickr_api_call('flickr.favorites.add', {'photo_id':ph['id']})

        if ok :
            self.notice("Added to your favorites")

        return
    
    #
    #
    #
    
    def flickr_api_call(self, method, args={}) :

        try :
            res = self.__fl__.execute_method(method, args)
        except Exception, e :
            self.error("API error : %s" % e)
            return None

        return self.test_flickr_rsp(res)

    #
    #
    #
    
    def test_flickr_rsp (self, res) :

        if not res :
            self.error("OMGWTF! No Flickr response")
    	    return None
    
        if res['stat'] != 'ok' :
    	    msg = "(%s) %s" % (res['code']. res['message'])
            self.error(msg)
            return None

        return res
        
    #
    #
    #
    
    def get_images (self) :

        self.start_beachball()
    	res = self.get_flickr_photos()
        self.stop_beachball()
        
        if not res :
    	    return False
            
	# 
        
        pending = len(self.__images__)

        self.record_activity("checking %s results" % len(res['photos']['photo']))
        self.start_beachball()
        
        for ph in res['photos']['photo'] :

            uid = self.uid_for_photo(ph)

            if self.__store__.read(uid) :
                # self.record_activity("skip %s (seen)" % uid)
                continue

            if uid in self.__pending__ :
                # self.record_activity("skip %s (pending)" % uid)
                continue
                
            # self.record_activity("add %s" % uid)
            
            self.__images__.append(ph)
            self.__pending__.append(uid)

        current = len(self.__images__)
        self.stop_beachball()
        
        # 

        self.record_activity("count : %s (%s)" % (pending, current))
                             
        if pending != current :
            new = (current - pending)
            
            self.record_activity("%s new images" % new)
            # self.record_activity("show : %s" % self.__show__)
            
            if not self.__show__ :
                self.show_next_image()
                
            self.vibrate()
        else :
            self.record_activity("no new images")
            self.__current__ = u''
            self.remove_flickr_photo()
            
        #
        
        return True

    #
    #
    #

    def fetch_image (self, url) :

        self.start_beachball()
        
        hex   = self.digesterize(url)
        store = unicode("c:\\fl-" + hex + ".jpg")

        self.record_activity("fetch image from flickr")

        if e32.in_emulator() :
            self.record_activity("url : %s" % url)
            
        #

        if not os.path.exists(store) :            
            try :
                urllib.urlretrieve(url, store)
            except Exception, e :
                self.error("Failed to retrieve image, %s" % e)
                self.stop_beachball()                
                return None

        #

        if e32.in_emulator() :
            os.unlink(store)
            self.stop_beachball()            
            return True

        self.record_activity("store thumb locally")

        try :
            image = graphics.Image.open(store)
        except Exception, e :
            self.error("Failed to open image, %s" % e)            
            os.unlink(store)
            self.stop_beachball()            
            return None
        
        os.unlink(store)

	#

	(w, h) = image.size
	image.rectangle((0, 0, (w-1) , (h-1)), outline=(0, 0, 0), width=2)        

	# 
        self.stop_beachball()        
        return image
    
    #
    #
    #

    def show_next_image (self) :

        if len(self.__images__) == 0 :
            self.remove_flickr_photo()
            self.log("Waiting for someone to take a picture...", True)        
            return False

	#
        
        ph  = self.__images__.pop(0)
        return self.show_flickr_photo_thumb(ph)

    #
    #
    #

    def remove_flickr_photo (self) :
        self.remove_image('photo')
        self.__ph__ = None

    #
    #
    #

    def toggle_flickr_photo (self) :
        ph = self.__ph__

        if self.__sz__ == 't' :
            return self.show_flickr_photo_small(ph)
        else :
            return self.show_flickr_photo_thumb(ph)

    #
    #
    #
    
    def show_flickr_photo_thumb (self, ph) :
        return self.show_flickr_photo(ph, 't')

    #
    #
    #
    
    def show_flickr_photo_small (self, ph) :
        return self.show_flickr_photo(ph, 'm')

    #
    #
    #
    
    def show_flickr_photo (self, ph, sz) :
        self.record_activity("show flickr photo %s" % sz)
        
        url = self.flickr_photo_url(ph, sz)

        try :        
            image = self.fetch_image(url)
        except Exception, e :
            self.error("Failed to fetch %s, %s" % (ph['title'], e))
            return False
        
        self.__ph__ = ph
        self.__sz__ = sz

        try :
            self.show_image(image, 'photo')
        except Exception, e :

            self.__ph__ = None
            self.__sz__ = None
            
            self.error("Failed to display %s, %s" % (ph['title'], e))
            return False
            
        self.display_photo_info(ph)
        self.mark_as_seen(ph)
        self.switch_to_app()
        
    #
    #
    #
    
    def flickr_photo_url (self, ph, sz) :
        url = "http://farm%s.static.flickr.com/%s/%s_%s_%s.jpg" % (ph['farm'], ph['server'], ph['id'], ph['secret'], sz)
        return url
    
    #
    #
    #
    
    def mark_as_seen(self, ph) :
        uid = self.uid_for_photo(ph)        

        if uid in self.__pending__ :
            self.__pending__.remove(uid)        
            self.__store__.write(uid, '1')
            self.__store__.save()
        
    #
    #
    #

    def show_icon (self) :

        icon_path = unicode("c:\\flickrwidgt_icon.gif")
        
        if e32.in_emulator() :
            icon_path = unicode("flickrwidgt_icon.gif")
	#
            
        if not os.path.exists(icon_path) :
            if not self.create_icon(icon_path) :
		return False

        #

        try :
    	    im = graphics.Image.open(icon_path)
    	except Exception, e :
            self.error("Unable to display icon (%s), %s" % (icon_path, e))
            return False

        self.show_image(im, 'icon')
        return True
    
    #
    #
    #
    
    def create_icon (self, icon_path) :

        remote_icon = 'http://aaronland.info/flickrwidgt_icon.gif'
        
        try :
            urllib.urlretrieve(remote_icon, icon_path)
        except Exception, e :
            self.error("Failed to retrieve icon, %s" % e)
            return False

        # self.record_activity("wrote icon file")
        return True

    #
    #
    #
    
    def show_beachball (self) :

        # self.record_activity("show beachball : %s" % self.__ball__)
        
        if self.__ball__ == 0 :
            return

        if self.__ball__ == 1 :
            self.show_number('.  ')
            self.__ball__ = 2
        elif self.__ball__ == 2 :
            self.show_number(' . ')
            self.__ball__ = 3            
        else :
            self.show_number('  .')
            self.__ball__ = 1

        self.__balltimer__.after(.5, self.show_beachball)

    #
    #
    #

    def start_beachball (self) :

        if self.__balltimer__ :
            return
            
        if e32.in_emulator() :
            return
        
        self.__ball__ = 1
        self.__balltimer__ = e32.Ao_timer()

        self.show_beachball()

    #
    #
    #
    
    def stop_beachball (self) :
        self.remove_image('beachball')
        self.__ball__ = 0
        self.__balltimer__ = None
        
    #
    #
    #
    
    def show_number(self, num) :
        sn = simplenumbers(num, 5)
        # sn.border(2)
        sn.fill((255, 0, 0))
        image = sn.draw()

        self.show_image(image, 'beachball')

    #
    #
    #

    def remove_image (self, type) :
        # self.record_activity("remove image %s" % type)
        
        if self.__tw__.has_key(type) :
            self.__tw__[type].hide()
            self.__tw__[type] = None
            
        if self.__twim__.has_key(type) :            
            self.__twim__[type] = None

    #
    #
    #
    
    def show_image (self, image, type) :
        # self.record_activity("show image %s" % type)
        
        if e32.in_emulator() :
             return True

        # 

        try :
            import topwindow
        except Exception, e :
            self.error("Can not load topwindow")
            return False

        try :
            if not self.__tw__.has_key(type) or not self.__tw__[type] :
                self.__tw__[type] = topwindow.TopWindow()

            tw = self.__tw__[type]
        
            tw.hide()

            if self.__twim__.has_key(type) and self.__twim__[type] :
                tw.remove_image(self.__twim__[type])
                self.__twim__[type] = None
                
            tw.size = image.size
            tw.position = self.image_position(image, type)

            scale = self.image_scale(image)
            tw.add_image(image, scale)
            
            tw.show()
        
            self.__twim__[type] = image
            
        except Exception, e :
            self.error("failed to create topwindow of type %s : %s" % (type, e))
            return False

        return True
    
    #
    #
    #

    def image_scale (self, image) :

        sz = image.size
        cv = appuifw.Canvas().size

        if sz[0] > cv[0] or sz[1] > cv[1] :
            sc = self.scalify(sz, cv)

            return (0, 0, sc[0], sc[1])
        else :
            return (0, 0)

    #
    #
    #
    
    def scalify (self, src, cvs) :

        (ix, iy) = src
        (cx, cy) = cvs
        
        if ix > iy :
            rx = int(cx)
            ry = int(cy * (float(cx) / float(ix)))
        else :
            rx = int(cx * (float(cy) / float(iy)))
            ry = int(cy)
        
        return (rx, ry)
    
    #
    #
    #
    
    def image_position (self, image, type) :
        sz = image.size
        
        cv = appuifw.Canvas()
        (cw, ch) = cv.size

        if type == 'photo' :
            if self.__sz__ == 'm' :
                return 0, 50
            return (cw - 25 - sz[0]), (ch - 20)
        elif type == 'icon' :
            return (cw - 25 - sz[0]), 20
        elif type == 'beachball' :
            return 0, (ch - sz[1])
        else :
            return 0, 0
    
    #
    #
    #

    def display_photo_info (self, ph) :

        cnt = len(self.__images__)
        
    	msg = "\"%s\"\n---\nby %s" % (ph['title'], ph['username'])
        
        if cnt :
            msg += "\n\n(%s images remaining)" % cnt

        self.__current__ = msg
        
        if self.__logs__ :
            return

        reset = True
	self.log(self.__current__, reset)
        
    #
    #
    #
    
    def digesterize (self, url) :
        return md5.md5(url).hexdigest()
    
    #
    #
    #

    def record_activity (self, msg) :
    	display = False
        
        if self.__show__ :
	    display = False

	simpleapp.record_activity(self, msg, display)

    #
    #
    #
    
    def uid_for_photo (self, ph) :
        uid = "ctx_%s_%s" % (self.__mode__, ph['id'])
        return unicode(uid)
    
    #
    #
    #

    def show_in_browser (self) :
        url = "http://m.flickr.com/photo.gne?id=%s" % self.__ph__['id']
        self.open_url(url)

    #
    #
    #
        
    def open_url (self, url) :

        self.record_activity("open %s" % url)
        
        if e32.in_emulator() :
            return
        
        apprun  = 'z:\\system\\programs\\apprun.exe'
        browser = 'z:\\System\\Apps\\Browser\\Browser.app'

        try :
            e32.start_exe(apprun, browser + ' "%s"' % url , 1)
        except Exception, e :
            self.error("Unable to open URL, %s" % e)

    #
    #
    #
    
if __name__ == "__main__" :
   
    key    = '50f8fe2a13c12d48ec4dfb1dc1f15cc8'
    secret = '856cfebaf6c12876'
    token  = '565-f3f9df204eb412c5'

    app = Flmoblshow(key, secret, token)
    app.loop()
