# -*-python-*-

__package__    = "s60-simplehttp.py"
__version__    = "1.0"
__author__     = "Aaron Straup Cope"
__url__        = "http://www.aaronland.info/python/s60-simplelibs/"
__cvsversion__ = "$Revision: 1.4 $"
__date__       = "$Date: 2007/05/17 16:50:09 $"
__copyright__  = "Copyright (c) 2006 Aaron Straup Cope. Perl Artistic License."

import httplib
import base64

class simplehttp :
    
    def __init__ (self, creds=None) :
        self.__auth__ = None
        
        if not creds == None :
            user = creds[0]
            pswd = creds[1]
            self.__auth__ = base64.encodestring(user + ":" + pswd)

    #
    #
    #
    
    def get (self, host, path, headers={}) :
        return self.execute_http_request('GET', host, path, headers)

    #
    #
    #

    def getstore (self, url, path='') :

        import md5
        import urllib
        
        if path == '' :
            path = md5.md5(url).hexdigest()

        if not e32.in_emulator() :
            import sysinfo

            if 'E:' in sysinfo.free_drivespace().keys() :
                path = 'e:\\%s' % path
            else :
                path = 'c:\\%s' % path
            
        try :
            urllib.urlretrieve(url, unicode(path))
        except Exception, e :
            raise Exception("Failed to retrieve image, %s" % e)
        
        return path
    
    #
    #
    #
    
    def post (self, host, path, params=None, headers={}) :
        return self.execute_http_request('POST', host, path, params)

    #
    #
    #
    
    def execute_http_request(self, meth, host, path, params=None, headers={}) :
        
        if self.__auth__ :
            headers['Authorization'] = "Basic %s" % self.__auth__

        c = httplib.HTTPConnection(host)
        c.request(meth, path, params, headers)
        
        r = c.getresponse()
        return r.read()
