# -*-python-*-

__package__    = "s60-simplenumbers.py"
__version__    = "1.0"
__author__     = "Aaron Straup Cope"
__url__        = "http://www.aaronland.info/python/s60-simplelibs/"
__cvsversion__ = "$Revision: 1.5 $"
__date__       = "$Date: 2007/05/17 16:50:10 $"
__copyright__  = "Copyright (c) 2006 Aaron Straup Cope. Perl Artistic License."

import graphics

class simplenumbers :

    def __init__ (self, num, sq=5) :
        self.__char__ = 3

        self.__border__ = 0
        self.__fill__   = (0,0,0)

        self.__num__ = num
        self.__sq__  = sq
        
    #
    #
    #
    
    def border (self, width=3) :
        self.__border__ = width

    #
    #
    #
    
    def fill (self, tpl) :
        self.__fill__ = tpl
        
    #
    #
    #
    
    def draw (self) :

        num   = str(self.__num__)
        count = len(num)
                            
        h = self.__sq__ * (5 + 2)
        w = self.__sq__ * ((count * 3) + (count - 1) + 2)

        #
        
        im = graphics.Image.new((w, h))
        
        x = self.__sq__
        y = self.__sq__
        
        for char in num :
            
            if char == '1' :
                self.one(im, x, y)
            elif char == '2' :
                self.two(im, x, y)
            elif char == '3' :
                self.three(im, x, y)
            elif char == '4' :
                self.four(im, x, y)                
            elif char == '5' :
                self.five(im, x, y)
            elif char == '6' :
                self.six(im, x, y)
            elif char == '7' :
                self.seven(im, x, y)                                
            elif char == '8' :
                self.eight(im, x, y)                
            elif char == '9' :
                self.nine(im, x, y)
            elif char == '0' :
                self.zero(im, x, y)                                
            elif char == '.' :
            	self.dot(im, x, y)
            else :
                pass

            x += self.__sq__ + (self.__sq__ * self.__char__)
            y  = self.__sq__            

        #
        
        if self.__border__ :
            im.rectangle((0, 0, w, h), outline=self.__fill__, width=self.__border__)

        #
        
        return im
    
    #
    # use draw_line; draw_rect
    #
    
    def one (self, im, x, y) :

        # cap

        x_start = x
        y_start = y        
        x_end   = x_start + self.__sq__
        y_end   = y_start + self.__sq__

        self.draw_rect(im, (x_start, y_start, x_end, y_end))
            
        # center bar
        
        x_start = x + self.__sq__
        y_start = y        
        x_end   = x_start + self.__sq__
        y_end   = y + (self.__sq__ * 4)
        
        self.draw_rect(im, (x_start, y_start, x_end, y_end))
        
        # foot

        x_start = x
        y_start = y + (self.__sq__ * 4)
        x_end   = x_start + (self.__sq__ * self.__char__)
        y_end   = y_start + self.__sq__

        self.draw_rect(im, (x_start, y_start, x_end, y_end))

    #
    #
    #
    
    def two (self, im, x, y) :

        # top
        self.draw_line(im, 'h', x, y)

        # foo
        y += self.__sq__
        
        self.draw_rect(im, (x + (self.__sq__ * 2),
                              y,
                              x + (self.__sq__ * 3),
                              y + self.__sq__))

        # center
        y += self.__sq__        
        self.draw_line(im, 'h', x, y)

        # bar
        y += self.__sq__

        self.draw_rect(im, (x,
                              y,
                              x + self.__sq__,
                              y + self.__sq__))

        # bottom
        y += self.__sq__
        self.draw_line(im, 'h', x, y)

    #
    #
    #

    def three (self, im, x, y) :

        # top
        self.draw_line(im, 'h', x, y)

        # foo
        y += self.__sq__
        
        self.draw_rect(im, (x + (self.__sq__ * 2),
                              y,
                              x + (self.__sq__ * 3),
                              y + self.__sq__))

        # center
        y += self.__sq__        
        self.draw_line(im, 'h', x, y)

        # bar
        y += self.__sq__

        self.draw_rect(im, (x + (self.__sq__ * 2),
                              y,
                              x + (self.__sq__ * 3),
                              y + self.__sq__))

        # bottom
        y += self.__sq__
        self.draw_line(im, 'h', x, y)

    #
    #
    #

    def four (self, im, x, y) :

        # left arm
        self.draw_rect(im, (x, y, x + self.__sq__, y + (self.__sq__ * 2)))
        
        # center
        self.draw_line(im, 'h', x, y + (self.__sq__ * 2))

        # right side
        self.draw_line(im, 'v', x + (self.__sq__ * 2), y)
    
    #
    #
    #

    def five (self, im, x, y) :

        # top
        self.draw_line(im, 'h', x, y)

        # foo
        y += self.__sq__

        self.draw_rect(im, (x,
                              y,
                              x + self.__sq__,
                              y + self.__sq__))

        # center
        y += self.__sq__        
        self.draw_line(im, 'h', x, y)

        # bar
        y += self.__sq__

        self.draw_rect(im, (x + (self.__sq__ * 2),
                              y,
                              x + (self.__sq__ * 3),
                              y + self.__sq__))

        # bottom
        y += self.__sq__
        self.draw_line(im, 'h', x, y)

    #
    #
    #

    def six (self, im, x, y) :

        # top
        self.draw_line(im, 'h', x, y)

        # foo
        y += self.__sq__

        self.draw_rect(im, (x,
                              y,
                              x + self.__sq__,
                              y + self.__sq__))

        # center
        y += self.__sq__        
        self.draw_line(im, 'h', x, y)

        # bar
        y += self.__sq__

        self.draw_rect(im, (x,
                              y,
                              x + self.__sq__,
                              y + self.__sq__))

        self.draw_rect(im, (x + (self.__sq__ * 2),
                              y,
                              x + (self.__sq__ * 3),
                              y + self.__sq__))

        # bottom
        y += self.__sq__
        self.draw_line(im, 'h', x, y)

    #
    #
    #

    def seven (self, im, x, y) :

        # top
        self.draw_line(im, 'h', x, y)

        # center
        self.draw_rect(im, (x + self.__sq__,
                              y + (self.__sq__ * 2),
                              x + (self.__sq__ * 2),
                              y + (self.__sq__ * 3)))

        # right side
        self.draw_line(im, 'v', x + (self.__sq__ * 2), y)

    #
    #
    #
    
    def eight (self, im, x, y) :

        # top
        self.draw_line(im, 'h', x, y)

        # left side
        self.draw_line(im, 'v', x, y)

        # center
        self.draw_line(im, 'h', x, y + (self.__sq__ * 2))

        # right side
        self.draw_line(im, 'v', x + (self.__sq__ * 2), y)
        
        # bottom
        self.draw_line(im, 'h', x, y + (self.__sq__ * 4))

    #
    #
    #
    
    def nine (self, im, x, y) :

        # top
        self.draw_line(im, 'h', x, y)

        # foo
        y += self.__sq__

        self.draw_rect(im, (x,
                              y,
                              x + self.__sq__,
                              y + self.__sq__))

        self.draw_rect(im, (x + (self.__sq__ * 2),
                              y,
                              x + (self.__sq__ * 3),
                              y + self.__sq__))

        # center
        y += self.__sq__        
        self.draw_line(im, 'h', x, y)

        # bar
        y += self.__sq__

        self.draw_rect(im, (x + (self.__sq__ * 2),
                              y,
                              x + (self.__sq__ * 3),
                              y + self.__sq__))

        # bottom
        y += self.__sq__
        self.draw_line(im, 'h', x, y)
    
    #
    #
    #

    def zero (self, im, x, y) :

        # top
        self.draw_line(im, 'h', x, y)

        # left side
        self.draw_line(im, 'v', x, y)

        # right side
        self.draw_line(im, 'v', x + (self.__sq__ * 2), y)
        
        # bottom
        self.draw_line(im, 'h', x, y + (self.__sq__ * 4))

    #
    #
    #

    def dot (self, im, x, y) :

	start_x = x + self.__sq__
        start_y = y + (self.__sq__ * 4)
        end_x = start_x + self.__sq__
        end_y = start_y + self.__sq__        
        
        self.draw_rect(im, (start_x, start_y, end_x, end_y))

    #
    #
    #
    
    def draw_line (self, im, dir, x, y) :

        if dir == 'h' :
            start_x = x
            start_y = y
            end_x   = start_x + (self.__sq__ * 3)
            end_y   = start_y + self.__sq__
            
        else :

            start_x = x
            start_y = y
            end_x   = start_x + self.__sq__
            end_y   = start_y + (self.__sq__ * 5)

        self.draw_rect(im, (start_x, start_y, end_x, end_y))
        
    #
    #
    #
    
    def draw_rect (self, im, coords) :
        im.rectangle(coords, fill=self.__fill__)

    #
    # END
    #
    
if __name__ == '__main__' :

    import appuifw
    import e32

    sz = 0
    im = None

    n = appuifw.query(unicode("enter a number"), "text")
    
    try :
        sn = simplenumbers(n)

        sn.border(2)
        sn.fill((255, 0, 0))
        
        im = sn.draw()
        
        sz = im.size
    except Exception, e :
        appuifw.note(unicode("IM %s" % e), "error")

    if e32.in_emulator() :
        txt = "size : %s" % str(sz)
        appuifw.note(unicode(txt), 'info')
    else :
        import topwindow

        try :
            tw = topwindow.TopWindow()
            tw.size = sz

            cv = appuifw.Canvas()
            cw = cv.size[0]
            
            tw.position = ((cw - 25 - sz[0]), 25)
            tw.shadow = 5
            
            tw.add_image(im, (0,0))
            tw.show()

            appuifw.app.menu = [
                (u"hide tw", tw.hide),
                (u"show tw", tw.show)
                ]
            
        except Exception, e :
            appuifw.note(unicode("TW %s" % e), "error")
