# -*-python-*-

__package__    = "s60-tools.py"
__version__    = "1.0"
__author__     = "Aaron Straup Cope"
__url__        = "http://www.aaronland.info/python/s60-simplelibs/"
__cvsversion__ = "$Revision: 1.8 $"
__date__       = "$Date: 2007/05/20 22:37:48 $"
__copyright__  = "Copyright (c) 2006 Aaron Straup Cope. Perl Artistic License."

import re
import os.path
import sys
from optparse import OptionParser
    
class s60tools :

    def buildify (self, options) :

        try :
            src_fh = open(options.input, "r")
        except Exception, e :
            print e
            return False

        #

        fh = sys.stdout
        
        if options.output :
            try :
                fh = open(options.output, "r")
            except Exception, e :
                print e
                return False

        #
        # Who am I ?
        # 

        re_homedir = re.compile(r"^~/")
        re_splat   = re.compile(r"^\*/")        
        re_meta    = re.compile(r"^__")
        re_comment = re.compile(r"^\s*#")
        re_blank   = re.compile(r"^$")        
        re_emacs   = re.compile(r"^#\s*-\*-")            
        re_main    = re.compile(r"^if\s+__name__\s*==\s*['\"]__main")
        re_inc     = re.compile(r"^#\s*s60_include\s*:\s*(.*)")

        #
        # I can see clearly now
        #
        
        if options.future :
            for thing in options.future :
                fh.write("from __future__ import %s\n" % thing)
            
        #
        # 
        #
        
        for ln in src_fh :

            m = re_inc.match(ln)
            
            if m :

                inc_file = m.groups()[0]
		inc_file = inc_file.strip()

                if re_splat.match(inc_file) :

                    if options.prefix :
                        inc_file = inc_file.replace("*", options.prefix)
                        inc_file = os.path.abspath(inc_file)
                    else :
                        fh.write("\n#\n")
                        fh.write("# failed to resolve prefix identifier; no prefix defined\n")
                        fh.write(ln)
                        fh.write("#\n")                        
                        continue
                        
                elif re_homedir.match(inc_file) :
                    import pwd
                    import posix

                    user = pwd.getpwuid(posix.geteuid())
                    homedir = os.path.abspath(user[5])
                    inc_file = inc_file.replace("~", homedir)
                else :
                    pass
                
                #
                
                try :
                    input_fh = open(inc_file, "r")
                except Exception, e :
                    fh.write("\n#\n")
                    fh.write("# failed to import '%s' :\n" % inc_file)
                    fh.write("# %s\n" % e)
                    fh.write("#\n")                    
                    continue

                fh.write("\n#\n")
                fh.write("# extlib : %s" % os.path.basename(inc_file))
                fh.write("\n#\n")
                
                for input_ln in input_fh :
                    baz = False

                    if re_main.match(input_ln) :
                        break
                    elif re_comment.match(input_ln) :
                        continue
                    elif re_blank.match(input_ln.strip()) :
                        continue
                    elif re_meta.match(input_ln) :
                        continue
                    elif re_emacs.match(input_ln) :
                        continue

                    else :
                        fh.write(input_ln)

                continue

            #
            
            else :
                fh.write(ln)
            
if __name__ == "__main__" :

    usage  = "%prog [options] -c buildify -i /my/s60/tool.py -p /my/lib/python\n\n"
    parser = OptionParser(usage=usage)
    
    parser.add_option("-c", "--command", type="string", dest="command", help="what you want s60-tools.py to do")
    parser.add_option("-i", "--input",   type="string", dest="input",   help="the path to the pys60 program you are working on")
    parser.add_option("-o", "--output",  type="string", dest="output",  help="the path for the output for the modified pys60 program; default is STDOUT")    
    parser.add_option("-p", "--prefix",  type="string", dest="prefix",  help="the path where your s60-simplelibs libraries are installed")
    parser.add_option("-f", "--future",  type="string", dest="future",  help="from __future__ import [this]", action="append")
    
    (options, args) = parser.parse_args()

    if options.command=='buildify' :
        t = s60tools()
        t.buildify(options)
        
    else :
        print "unknown command";
